Index: branches/gui/src/util/hud.cc
===================================================================
--- branches/gui/src/util/hud.cc	(revision 8516)
+++ branches/gui/src/util/hud.cc	(revision 8517)
@@ -23,4 +23,7 @@
 #include "glgui_widget.h"
 
+#include "glgui_inputline.h"
+#include "specials/glgui_notifier.h"
+
 /**
  * standard constructor
@@ -39,4 +42,12 @@
   this->resY = 1;
 
+  this->inputLine = new OrxGui::GLGuiInputLine();
+  this->inputLine->setParent2D(this);
+  this->notifier = new OrxGui::GLGuiNotifier();
+  this->notifier->setParent2D(this);
+  notifier->setAbsCoor2D(100,100);
+
+
+
 }
 
@@ -47,4 +58,6 @@
 Hud::~Hud ()
 {
+  delete this->inputLine;
+  delete this->notifier;
   // delete what has to be deleted here
 }
@@ -56,7 +69,11 @@
 }
 
+void Hud::notifyUser(const std::string& message)
+{
+  this->notifier->pushNotifyMessage(message);
+}
+
 void Hud::setBackGround()
-{
-}
+{}
 
 void Hud::setEnergyWidget(OrxGui::GLGuiWidget* widget)
@@ -74,6 +91,6 @@
     this->energyWidget->backMaterial().setDiffuseMap("hud_energy_background.png");
     this->energyWidget->backMaterial().setBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
-/*    this->energyWidget->frontMaterial().setDiffuseMap("hud_energy_bar.png");
-    this->energyWidget->frontMaterial().setBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);*/
+    /*    this->energyWidget->frontMaterial().setDiffuseMap("hud_energy_bar.png");
+        this->energyWidget->frontMaterial().setBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);*/
   }
 
@@ -82,10 +99,8 @@
 
 void Hud::setShiledWidget(OrxGui::GLGuiWidget* widget)
-{
-}
+{}
 
 void Hud::setArmorWidget(OrxGui::GLGuiWidget* widget)
-{
-}
+{}
 
 void Hud::setWeaponManager(WeaponManager* weaponMan)
@@ -123,26 +138,24 @@
   if (this->weaponManager != NULL)
     for (unsigned int i = 0; i < this->weaponManager->getSlotCount(); i++)
-  {
-    Weapon* weapon = this->weaponManager->getWeapon(i);
-    if (weapon != NULL)
     {
-      weapon->getEnergyWidget()->show();
-      weapon->getEnergyWidget()->backMaterial().setDiffuse( .8,.2,.11);
-      weapon->getEnergyWidget()->backMaterial().setTransparency(.1);
-      weapon->getEnergyWidget()->setFrontColor(Color( .2,.5,.7,.6));
-//      weapon->getEnergyWidget()->frontMaterial().setTransparency(.6);
-      this->weaponsWidgets.push_back(weapon->getEnergyWidget());
+      Weapon* weapon = this->weaponManager->getWeapon(i);
+      if (weapon != NULL)
+      {
+        weapon->getEnergyWidget()->show();
+        weapon->getEnergyWidget()->backMaterial().setDiffuse( .8,.2,.11);
+        weapon->getEnergyWidget()->backMaterial().setTransparency(.1);
+        weapon->getEnergyWidget()->setFrontColor(Color( .2,.5,.7,.6));
+        //      weapon->getEnergyWidget()->frontMaterial().setTransparency(.6);
+        this->weaponsWidgets.push_back(weapon->getEnergyWidget());
+      }
     }
-  }
   this->updateResolution();
 }
 
 void Hud::addWeaponWidget(OrxGui::GLGuiWidget* widget)
-{
-}
+{}
 
 void Hud::removeWeaponWidget(OrxGui::GLGuiWidget* widget)
-{
-}
+{}
 
 void Hud::updateResolution()
@@ -162,6 +175,6 @@
   for (weaponWidget = this->weaponsWidgets.begin(); weaponWidget != this->weaponsWidgets.end(); weaponWidget++, pos+=.03)
   {
-      (*weaponWidget)->setSize2D(.02*this->resX, .2 *this->resY);
-      (*weaponWidget)->setAbsCoor2D(pos*this->resX, .75*this->resY);
+    (*weaponWidget)->setSize2D(.02*this->resX, .2 *this->resY);
+    (*weaponWidget)->setAbsCoor2D(pos*this->resX, .75*this->resY);
 
   }
@@ -171,11 +184,14 @@
 void Hud::tick(float dt)
 {
-  if (this->resY != State::getResY() || this->resX != State::getResY())
+  if (this->resY != State::getResY() || this->resX != State::getResX())
+  {
     this->updateResolution();
+  }
+
 }
 
 void Hud::draw() const
 {
-//  GLGuiWidget::draw();
+  //  GLGuiWidget::draw();
 }
 
Index: branches/gui/src/util/hud.h
===================================================================
--- branches/gui/src/util/hud.h	(revision 8516)
+++ branches/gui/src/util/hud.h	(revision 8517)
@@ -10,6 +10,12 @@
 // FORWARD DECLARATION
 class TiXmlElement;
+
 class WeaponManager;
-namespace OrxGui { class GLGuiWidget; }
+namespace OrxGui {
+  class GLGuiWidget;
+  class GLGuiNotifier;
+  class GLGuiInputLine;
+
+}
 
 //! A class that renders a HUD.
@@ -23,4 +29,7 @@
 
   virtual void loadParams(const TiXmlElement* root);
+
+  void notifyUser(const std::string& message);
+
 
   void setBackGround();
@@ -49,4 +58,7 @@
   OrxGui::GLGuiWidget*     armorWidget;
 
+  OrxGui::GLGuiNotifier*   notifier;
+  OrxGui::GLGuiInputLine*  inputLine;
+
   WeaponManager*           weaponManager;
 