Index: trunk/src/defs/class_id.h
===================================================================
--- trunk/src/defs/class_id.h	(revision 8495)
+++ trunk/src/defs/class_id.h	(revision 8518)
@@ -363,4 +363,6 @@
   CL_GLGUI_IMAGE                =    0x00000b70,
 
+  CL_GLGUI_NOTIFIER             =    0x00000b80,
+
   // QT_GUI
   CL_GUI_SAVEABLE               =    0x00b10000,
Index: trunk/src/lib/graphics/graphics_engine.cc
===================================================================
--- trunk/src/lib/graphics/graphics_engine.cc	(revision 8495)
+++ trunk/src/lib/graphics/graphics_engine.cc	(revision 8518)
@@ -405,4 +405,14 @@
   this->setResolution(this->resolutionX, this->resolutionY, this->bitsPerPixel);
 }
+
+void GraphicsEngine::toggleFullscreen()
+{
+  if (this->fullscreenFlag == SDL_FULLSCREEN)
+    this->fullscreenFlag = 0;
+  else
+    this->fullscreenFlag = SDL_FULLSCREEN;
+  this->setResolution(this->resolutionX, this->resolutionY, this->bitsPerPixel);
+}
+
 
 /**
Index: trunk/src/lib/graphics/graphics_engine.h
===================================================================
--- trunk/src/lib/graphics/graphics_engine.h	(revision 8495)
+++ trunk/src/lib/graphics/graphics_engine.h	(revision 8518)
@@ -44,4 +44,5 @@
     int setResolution(int width, int height, int bpp);
     void setFullscreen(bool fullscreen = false);
+    void toggleFullscreen();
     static void setBackgroundColor(GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha = 1.0);
 
Index: trunk/src/lib/graphics/text_engine/text.cc
===================================================================
--- trunk/src/lib/graphics/text_engine/text.cc	(revision 8495)
+++ trunk/src/lib/graphics/text_engine/text.cc	(revision 8518)
@@ -159,4 +159,13 @@
 }
 
+
+/**
+ * @brief clears the Text Line (empies it).
+ */
+void Text::clear()
+{
+  text.clear();
+  this->setupTextWidth();
+}
 
 /**
Index: trunk/src/lib/graphics/text_engine/text.h
===================================================================
--- trunk/src/lib/graphics/text_engine/text.h	(revision 8495)
+++ trunk/src/lib/graphics/text_engine/text.h	(revision 8518)
@@ -40,4 +40,5 @@
     const std::string& operator<<(const std::string& appendText);
     void removeCharacters(unsigned int chars);
+    void clear();
 
     /// SETUP
Index: trunk/src/lib/gui/gl/Makefile.am
===================================================================
--- trunk/src/lib/gui/gl/Makefile.am	(revision 8495)
+++ trunk/src/lib/gui/gl/Makefile.am	(revision 8518)
@@ -29,5 +29,7 @@
 		glgui_image.cc \
 		glgui_window.cc \
-		glgui_cursor.cc
+		glgui_cursor.cc \
+		\
+		specials/glgui_notifier.cc
 
 
@@ -54,5 +56,8 @@
 		glgui_image.h \
 		glgui_window.h \
-		glgui_cursor.h
+		glgui_cursor.h \
+		\
+		specials/glgui_notifier.h
+
 
 
Index: trunk/src/lib/gui/gl/glgui_inputline.cc
===================================================================
--- trunk/src/lib/gui/gl/glgui_inputline.cc	(revision 8495)
+++ trunk/src/lib/gui/gl/glgui_inputline.cc	(revision 8518)
@@ -48,4 +48,5 @@
     this->setFocusable(true);
 
+    this->_clearOnEnter = false;
     this->_text.setParent2D(this);
     this->_text.setRelCoor2D(4,4);
@@ -100,4 +101,10 @@
   }
 
+  void GLGuiInputLine::clear()
+  {
+    this->_text.clear();
+    this->changedText();
+  }
+
   /**
    * @brief If the Text has been changed this function is called.
@@ -124,4 +131,17 @@
   }
 
+  /**
+   * @brief handles the EnterPush-Event.
+   *
+   * Emmits th EnterPushed Signal with the current Line,
+   * and if _clearOnEnter is pushed clears the Line.
+   */
+  void GLGuiInputLine::pushEnter()
+  {
+    emit(this->enterPushed(this->_text.getText()));
+    if (this->_clearOnEnter)
+      this->clear();
+  }
+
 
   /**
@@ -140,4 +160,9 @@
         this->pressedKeyName = SDLK_BACKSPACE;
         this->removeCharacters(1);
+        return true;
+      }
+      else if(event.type == SDLK_RETURN || event.type == SDLK_KP_ENTER)
+      {
+        this->pushEnter();
         return true;
       }
Index: trunk/src/lib/gui/gl/glgui_inputline.h
===================================================================
--- trunk/src/lib/gui/gl/glgui_inputline.h	(revision 8495)
+++ trunk/src/lib/gui/gl/glgui_inputline.h	(revision 8518)
@@ -38,4 +38,7 @@
     void appendCharacter(char character);
     void removeCharacters(unsigned int chars);
+    void clear();
+
+    void clearOnEnter(bool clear = true) { this->_clearOnEnter = clear; };
 
     virtual void removedFocus();
@@ -47,4 +50,5 @@
 
     DeclareSignal1(textChanged, const std::string&);
+    DeclareSignal1(enterPushed, const std::string&);
 
   protected:
@@ -57,8 +61,11 @@
   private:
     void init();
+    void pushEnter();
     void changedText();
+
 
   private:
     Text                    _text;            //!< The Text to display inside of the InputLine.
+    bool                    _clearOnEnter;    //!< Clear on Enter
 
     Uint16                  pressedKey;       //!< the pressed key that will be repeated.
Index: trunk/src/lib/gui/gl/glgui_style.cc
===================================================================
--- trunk/src/lib/gui/gl/glgui_style.cc	(revision 8495)
+++ trunk/src/lib/gui/gl/glgui_style.cc	(revision 8518)
@@ -29,4 +29,8 @@
   GLGuiStyle::GLGuiStyle (const TiXmlElement* root)
   {
+    _font = NULL;
+    this->reset();
+
+
     if (root != NULL)
       this->loadParams(root);
@@ -43,7 +47,24 @@
   }
 
+  void GLGuiStyle::reset()
+  {
+    this->setBorderLeft(1.0);
+    this->setBorderRight(1.0);
+    this->setBorderTop(1.0);
+    this->setBorderBottom(1.0);
+
+    this->setTextSize(20.0);
+    this->setBackgroundColor(1.0);
+    this->setForegroundColor(1.0);
+
+    this->setFeaturePosition(FeatureLeft);
+    this->setFont(NULL);
+
+    this->setAnimated(true);
+    this->setAnimatedStateChanges(true);
+  }
+
   void GLGuiStyle::loadParams(const TiXmlElement* root)
-  {
-  }
+  {}
 
   void GLGuiStyle::setBorderLeft(float value)
@@ -54,8 +75,11 @@
 
   void GLGuiStyle::setBorderLeft(float value, OrxGui::State state)
-{}
+  {
+    _style[state]._borderLeft = value;
+  }
 
   void GLGuiStyle::setBorderLeftS(float value, const std::string& state)
-  {}
+  {
+  }
 
 
@@ -67,5 +91,7 @@
 
   void GLGuiStyle::setBorderRight(float value, OrxGui::State state)
-{}
+  {
+    _style[state]._borderRight = value;
+  }
 
   void GLGuiStyle::setBorderRightS(float value, const std::string& state)
@@ -80,5 +106,7 @@
 
   void GLGuiStyle::setBorderTop(float value, OrxGui::State state)
-{}
+  {
+    _style[state]._borderTop = value;
+  }
 
   void GLGuiStyle::setBorderTopS(float value, const std::string& state)
@@ -93,5 +121,7 @@
 
   void GLGuiStyle::setBorderBottom(float value, OrxGui::State state)
-{}
+  {
+    _style[state]._borderBottom = value;
+  }
 
   void GLGuiStyle::setBorderBottomS(float value, const std::string& state)
@@ -106,5 +136,7 @@
 
   void GLGuiStyle::setTextSize(float value, OrxGui::State state)
-{}
+  {
+    _style[state]._textSize = value;
+  }
 
   void GLGuiStyle::setTextSizeS(float value, const std::string& state)
@@ -119,5 +151,7 @@
 
   void GLGuiStyle::setBackgroundColor(const Color& color, OrxGui::State state)
-{}
+  {
+    _style[state]._backgroundColor = color;
+  }
 
   void GLGuiStyle::setBackgroundColorS(float r, float g, float b, float a, const std::string& state)
@@ -132,5 +166,7 @@
 
   void GLGuiStyle::setBackgroundTexture(const Texture& texture, OrxGui::State state)
-{}
+  {
+    _style[state]._backgroundTexture = texture;
+  }
 
   void GLGuiStyle::setBackgroundTexture(const std::string& textureName, const std::string& state)
@@ -145,5 +181,7 @@
 
   void GLGuiStyle::setForegroundColor(const Color& color, OrxGui::State state)
-  {}
+  {
+    _style[state]._foregroundColor = color;
+  }
 
   void GLGuiStyle::setForegroundColorS(float r, float g, float b, float a, const std::string& state)
@@ -158,7 +196,5 @@
 
   void GLGuiStyle::setFeaturePosition(const std::string& featurePosition)
-  {
-
-  }
+  {}
 
 
@@ -179,5 +215,5 @@
   }
 
-  void GLGuiStyle::animatedStateChanges(bool animated)
+  void GLGuiStyle::setAnimatedStateChanges(bool animated)
   {
     this->_animatedStateChanges = animated;
Index: trunk/src/lib/gui/gl/glgui_style.h
===================================================================
--- trunk/src/lib/gui/gl/glgui_style.h	(revision 8495)
+++ trunk/src/lib/gui/gl/glgui_style.h	(revision 8518)
@@ -43,4 +43,5 @@
 
     /// SETUP
+    void reset();
     void loadParams(const TiXmlElement* root);
 
@@ -85,5 +86,5 @@
 
     void setAnimated(bool animated);
-    void animatedStateChanges(bool animated);
+    void setAnimatedStateChanges(bool animated);
 
   private:
Index: trunk/src/lib/gui/gl/glgui_widget.h
===================================================================
--- trunk/src/lib/gui/gl/glgui_widget.h	(revision 8495)
+++ trunk/src/lib/gui/gl/glgui_widget.h	(revision 8518)
@@ -66,4 +66,7 @@
     void disconnect(GLGuiWidget* sender, Signal& signal, BaseObject* receiver);
 
+
+    GLGuiStyle& style() { return this->_style; };
+    const GLGuiStyle style() const { return this->_style; };
 
     /// MATERIAL (looks)
Index: trunk/src/lib/gui/gl/specials/glgui_notifier.cc
===================================================================
--- trunk/src/lib/gui/gl/specials/glgui_notifier.cc	(revision 8518)
+++ trunk/src/lib/gui/gl/specials/glgui_notifier.cc	(revision 8518)
@@ -0,0 +1,202 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Benjamin Grauer
+   co-programmer: ...
+*/
+
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_SHELL
+
+#include "glgui_notifier.h"
+#include "multi_line_text.h"
+
+#include "debug.h"
+
+namespace OrxGui
+{
+
+  /**
+   * standard constructor
+   */
+  GLGuiNotifier::GLGuiNotifier ()
+  {
+    this->setClassID(CL_GLGUI_NOTIFIER, "GLGuiNotifier");
+
+    // Element2D and generals
+    this->lineSpacing = 0;
+    this->linesProcessed = 0;
+
+    this->setDisplayLineCount(10);
+  }
+
+  /**
+   * @brief standard deconstructor
+   */
+  GLGuiNotifier::~GLGuiNotifier ()
+  {
+    // delete the displayable Buffers
+    /*    while (!this->displayLines.empty())
+        {
+          delete this->displayLines.front().text;
+          this->displayLines.pop_front();
+        }
+
+        while (!this->hiddenText.empty())
+        {
+          delete this->hiddenText.top();
+          this->hiddenText.pop();
+        }*/
+  }
+
+  void GLGuiNotifier::pushNotifyMessage(const std::string& message)
+  {
+    if (!this->hiddenText.empty())
+    {
+      printf("%s\n", message.c_str());
+      DisplayLine dl;
+      dl.text = this->hiddenText.top();
+
+      dl.text->setBlending(1.0f);
+      dl.text->setText(message);
+      this->hiddenText.pop();
+      dl.age = 0.0f;
+      this->displayLines.push_front(dl);
+
+      dl.text->setVisibility(true);
+      dl.text->setRelCoor2D(this->calculateLinePosition(0));
+      this->repositionText();
+    }
+    else
+    {
+      this->inputBuffer.push_front(message);
+      //printf("grumble... must be fixed\n");
+    }
+  }
+
+
+  void GLGuiNotifier::setDisplayLineCount(unsigned int count)
+  {
+    unsigned int currentCount = displayLines.size() + hiddenText.size();
+
+    for (unsigned int i = currentCount; i < count; ++i)
+    {
+      MultiLineText* text = new MultiLineText();
+      this->applyTextSettings(text);
+      this->hiddenText.push(text);
+    }
+    bufferDisplaySize = count;
+  }
+
+
+  /**
+   * @brief repositiones all the Texts to their position.
+   */
+  void GLGuiNotifier::repositionText()
+  {
+    int linePos = -1;
+    std::list<DisplayLine>::iterator textIt;
+    for (textIt = this->displayLines.begin() ; textIt != this->displayLines.end(); ++textIt )
+    {
+      linePos += (*textIt).text->getLineCount();
+      (*textIt).text->setRelCoorSoft2D(this->calculateLinePosition(linePos), 8);
+      //      printf("%f %f\n", (*textIt).text->getAbsCoor2D().x, (*textIt).text->getAbsCoor2D().y);
+    }
+  }
+
+
+  /**
+   * @brief applies the GLGuiNotifiers Settings to a single Text of the GLGuiNotifier.
+   * @param text the Text to apply the settings to.
+   */
+  void GLGuiNotifier::applyTextSettings(MultiLineText* text)
+  {
+    text->setSize(this->style().textSize());
+    text->setLineWidth( 300 );
+    text->setFont("fonts/final_frontier.ttf", (int)this->style().textSize());
+
+    text->setColor(this->style().foregroundColor() );
+    if (text->getParent2D() != this)
+      text->setParent2D(this);
+  }
+
+
+  void GLGuiNotifier::tick(float dt)
+  {
+    std::list<DisplayLine>::iterator line;
+    for (line = this->displayLines.begin() ; line != this->displayLines.end(); ++line )
+    {
+      (*line).age+=dt;
+      if ((*line).age > 3.0f)
+      {
+        (*line).text->setBlending(4.0 - (*line).age);
+        if ((*line).age > 4.0f)
+        {
+          std::list<DisplayLine>::iterator tmp = line;
+          ++line;
+
+          (*tmp).text->setVisibility(false);
+          this->hiddenText.push((*tmp).text);
+          this->displayLines.erase(tmp);
+
+          if (!inputBuffer.empty())
+          {
+            this->pushNotifyMessage(inputBuffer.back());
+            inputBuffer.pop_back();
+          }
+        }
+      }
+    }
+  }
+
+
+  /**
+   * displays the GLGuiNotifier
+   */
+  void GLGuiNotifier::draw() const
+  {
+    // transform for alignment.
+    // setting the Blending effects
+    this->beginDraw();
+
+    this->backMaterial().select();
+    this->drawRect(this->backRect());
+    this->endDraw();
+  }
+
+  ///////////////////////
+  // HELPER FUNCTIONS  //
+  ///////////////////////
+
+  /**
+   * @brief calculates the position of a Buffer-Display Line
+   * @param lineNumber the lineNumber from the bottom to calculate the position from
+   * @returns the Position of the Line.
+   */
+  Vector2D GLGuiNotifier::calculateLinePosition(unsigned int lineNumber)
+  {
+    return Vector2D(0.0f, (float)(this->style().textSize() + this->lineSpacing)*(float)((int)this->bufferDisplaySize - (int)lineNumber - (int)1));
+  }
+
+
+  void GLGuiNotifier::resize()
+  {}
+
+  /**
+   * @brief displays some nice output from the GLGuiNotifier
+   */
+  void GLGuiNotifier::debug() const
+  {
+    PRINT(3)("Debugging output to console (not this shell)\n");
+
+    //   if (this->pressedKey != SDLK_FIRST)
+    //     printf("%s::%f %f\n", SDLKToKeyname(this->pressedKey), this->delayed, this->repeatDelay);
+  }
+}
Index: trunk/src/lib/gui/gl/specials/glgui_notifier.h
===================================================================
--- trunk/src/lib/gui/gl/specials/glgui_notifier.h	(revision 8518)
+++ trunk/src/lib/gui/gl/specials/glgui_notifier.h	(revision 8518)
@@ -0,0 +1,80 @@
+/*!
+ * @file shell.h
+ * Definition of a on-screen-shell
+ *
+ * @todo Buffer Display in different Colors for different debug mode.
+ * @todo choose color of the Font and the background.
+ */
+
+#ifndef _GLGUI_NOTIFIER_H
+#define _GLGUI_NOTIFIER_H
+
+#include "glgui_widget.h"
+#include "event_listener.h"
+
+#include <stack>
+
+// FORWARD DECLARATION
+class MultiLineText;
+class Text;
+
+//! Namespace of the GLGuiNotifier of ORXONOX.
+namespace OrxGui
+{
+  class GLGuiNotifier : public GLGuiWidget
+  {
+  public:
+    GLGuiNotifier();
+    virtual ~GLGuiNotifier();
+
+    void pushNotifyMessage(const std::string& message);
+
+    // BUFFERS
+    void setDisplayLineCount(unsigned int count);
+
+    void clear();
+
+    // Element2D-functions
+    virtual void tick(float dt);
+    virtual void draw() const;
+
+    void debug() const;
+
+  protected:
+    virtual void resize();
+
+  private:
+    void repositionText();
+    void applyTextSettings(MultiLineText* text);
+    void applySettings();
+    // helpers //
+    Vector2D calculateLinePosition(unsigned int lineNumber);
+
+
+
+  private:
+    typedef struct
+    {
+      float             age;
+      MultiLineText*    text;
+
+    }
+    DisplayLine;
+
+    unsigned int                lineSpacing;            //!< The Spacing between lines.
+
+    // BUFFER
+    unsigned int                bufferDisplaySize;      //!< The Size of the Display-buffer, in lines (not in characters).
+    std::list<DisplayLine>      displayLines;           //!< A list of stored bufferTexts for the display of the buffer.
+
+    std::stack<MultiLineText*>  hiddenText;             //!< Text that is not shown, and not used is thrown in here
+
+
+    unsigned long               linesProcessed;         //!< How many Lines have been processed so far.
+    std::list<std::string>      inputBuffer;            //!<
+
+  };
+
+}
+
+#endif /* _GLGUI_NOTIFIER_H */
Index: trunk/src/story_entities/simple_game_menu.cc
===================================================================
--- trunk/src/story_entities/simple_game_menu.cc	(revision 8495)
+++ trunk/src/story_entities/simple_game_menu.cc	(revision 8518)
@@ -42,4 +42,5 @@
 
 #include "glgui.h"
+#include "gui/gl/specials/glgui_notifier.h"
 
 //! This creates a Factory to fabricate a SimpleGameMenu
@@ -88,4 +89,10 @@
 {
 
+  OrxGui::GLGuiNotifier* notifier = new OrxGui::GLGuiNotifier();
+  notifier->show();
+  notifier->setAbsCoor2D(300, 300);
+
+
+
   OrxGui::GLGuiBox* box = new OrxGui::GLGuiBox();
   {
@@ -100,7 +107,13 @@
     box->pack(rdnpb);
 
+    OrxGui::GLGuiCheckButton* fullscreen = new OrxGui::GLGuiCheckButton("Fullscreen");
+    fullscreen->connect(SIGNAL(fullscreen, toggled), GraphicsEngine::getInstance(), SLOT(GraphicsEngine, setFullscreen));
+
+    box->pack(fullscreen);
+
     OrxGui::GLGuiInputLine* input = new OrxGui::GLGuiInputLine();
     input->setText("input some text here");
-    input->connect(SIGNAL(input, textChanged), this, SLOT(SimpleGameMenu, TEST));
+    input->connect(SIGNAL(input, textChanged), notifier, SLOT(OrxGui::GLGuiNotifier, pushNotifyMessage));
+
     box->pack(input);
 
Index: trunk/src/util/hud.cc
===================================================================
--- trunk/src/util/hud.cc	(revision 8495)
+++ trunk/src/util/hud.cc	(revision 8518)
@@ -23,4 +23,7 @@
 #include "glgui_widget.h"
 
+#include "glgui_inputline.h"
+#include "specials/glgui_notifier.h"
+
 /**
  * standard constructor
@@ -39,4 +42,12 @@
   this->resY = 1;
 
+  this->inputLine = new OrxGui::GLGuiInputLine();
+  this->inputLine->setParent2D(this);
+  this->notifier = new OrxGui::GLGuiNotifier();
+  this->notifier->setParent2D(this);
+  notifier->setAbsCoor2D(100,100);
+
+
+
 }
 
@@ -47,4 +58,6 @@
 Hud::~Hud ()
 {
+  delete this->inputLine;
+  delete this->notifier;
   // delete what has to be deleted here
 }
@@ -56,7 +69,11 @@
 }
 
+void Hud::notifyUser(const std::string& message)
+{
+  this->notifier->pushNotifyMessage(message);
+}
+
 void Hud::setBackGround()
-{
-}
+{}
 
 void Hud::setEnergyWidget(OrxGui::GLGuiWidget* widget)
@@ -74,6 +91,6 @@
     this->energyWidget->backMaterial().setDiffuseMap("hud_energy_background.png");
     this->energyWidget->backMaterial().setBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
-/*    this->energyWidget->frontMaterial().setDiffuseMap("hud_energy_bar.png");
-    this->energyWidget->frontMaterial().setBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);*/
+    /*    this->energyWidget->frontMaterial().setDiffuseMap("hud_energy_bar.png");
+        this->energyWidget->frontMaterial().setBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);*/
   }
 
@@ -82,10 +99,8 @@
 
 void Hud::setShiledWidget(OrxGui::GLGuiWidget* widget)
-{
-}
+{}
 
 void Hud::setArmorWidget(OrxGui::GLGuiWidget* widget)
-{
-}
+{}
 
 void Hud::setWeaponManager(WeaponManager* weaponMan)
@@ -123,26 +138,24 @@
   if (this->weaponManager != NULL)
     for (unsigned int i = 0; i < this->weaponManager->getSlotCount(); i++)
-  {
-    Weapon* weapon = this->weaponManager->getWeapon(i);
-    if (weapon != NULL)
     {
-      weapon->getEnergyWidget()->show();
-      weapon->getEnergyWidget()->backMaterial().setDiffuse( .8,.2,.11);
-      weapon->getEnergyWidget()->backMaterial().setTransparency(.1);
-      weapon->getEnergyWidget()->setFrontColor(Color( .2,.5,.7,.6));
-//      weapon->getEnergyWidget()->frontMaterial().setTransparency(.6);
-      this->weaponsWidgets.push_back(weapon->getEnergyWidget());
+      Weapon* weapon = this->weaponManager->getWeapon(i);
+      if (weapon != NULL)
+      {
+        weapon->getEnergyWidget()->show();
+        weapon->getEnergyWidget()->backMaterial().setDiffuse( .8,.2,.11);
+        weapon->getEnergyWidget()->backMaterial().setTransparency(.1);
+        weapon->getEnergyWidget()->setFrontColor(Color( .2,.5,.7,.6));
+        //      weapon->getEnergyWidget()->frontMaterial().setTransparency(.6);
+        this->weaponsWidgets.push_back(weapon->getEnergyWidget());
+      }
     }
-  }
   this->updateResolution();
 }
 
 void Hud::addWeaponWidget(OrxGui::GLGuiWidget* widget)
-{
-}
+{}
 
 void Hud::removeWeaponWidget(OrxGui::GLGuiWidget* widget)
-{
-}
+{}
 
 void Hud::updateResolution()
@@ -162,6 +175,6 @@
   for (weaponWidget = this->weaponsWidgets.begin(); weaponWidget != this->weaponsWidgets.end(); weaponWidget++, pos+=.03)
   {
-      (*weaponWidget)->setSize2D(.02*this->resX, .2 *this->resY);
-      (*weaponWidget)->setAbsCoor2D(pos*this->resX, .75*this->resY);
+    (*weaponWidget)->setSize2D(.02*this->resX, .2 *this->resY);
+    (*weaponWidget)->setAbsCoor2D(pos*this->resX, .75*this->resY);
 
   }
@@ -171,11 +184,14 @@
 void Hud::tick(float dt)
 {
-  if (this->resY != State::getResY() || this->resX != State::getResY())
+  if (this->resY != State::getResY() || this->resX != State::getResX())
+  {
     this->updateResolution();
+  }
+
 }
 
 void Hud::draw() const
 {
-//  GLGuiWidget::draw();
+  //  GLGuiWidget::draw();
 }
 
Index: trunk/src/util/hud.h
===================================================================
--- trunk/src/util/hud.h	(revision 8495)
+++ trunk/src/util/hud.h	(revision 8518)
@@ -10,6 +10,12 @@
 // FORWARD DECLARATION
 class TiXmlElement;
+
 class WeaponManager;
-namespace OrxGui { class GLGuiWidget; }
+namespace OrxGui {
+  class GLGuiWidget;
+  class GLGuiNotifier;
+  class GLGuiInputLine;
+
+}
 
 //! A class that renders a HUD.
@@ -23,4 +29,7 @@
 
   virtual void loadParams(const TiXmlElement* root);
+
+  void notifyUser(const std::string& message);
+
 
   void setBackGround();
@@ -49,4 +58,7 @@
   OrxGui::GLGuiWidget*     armorWidget;
 
+  OrxGui::GLGuiNotifier*   notifier;
+  OrxGui::GLGuiInputLine*  inputLine;
+
   WeaponManager*           weaponManager;
 