Index: /branches/atmospheric_engine/src/lib/graphics/effects/fog_effect.cc
===================================================================
--- /branches/atmospheric_engine/src/lib/graphics/effects/fog_effect.cc	(revision 8520)
+++ /branches/atmospheric_engine/src/lib/graphics/effects/fog_effect.cc	(revision 8521)
@@ -87,8 +87,7 @@
 
 void FogEffect::activate() {
-    PRINTF(0)( "Enabling FogEffect, mode: %i, density: %f, start: %f, end: %f, color %f, %f, %f\n", this->fogMode, this->fogDensity, this->fogStart, this->fogEnd, this->colorVector.x, this->colorVector.y, this->colorVector.z);
+    PRINTF(0)( "Activating FogEffect\n");
 
-    this->fogActivate = true;
-
+    // init fogGL
     GLfloat fogColor[4] = { colorVector.x, colorVector.y, colorVector.z, 1.0};
     glFogi(GL_FOG_MODE, this->fogMode);
@@ -98,4 +97,6 @@
     glFogf(GL_FOG_START, this->fogStart);
     glFogf(GL_FOG_END, this->fogEnd);
+
+    this->fogActivate = true;
 
     glEnable(GL_FOG);
@@ -127,4 +128,5 @@
 
 void FogEffect::tick(float dt) {
+
     if (!this->fogActivate)
         return;
@@ -193,15 +195,2 @@
 }
 
-
-GLint FogEffect::stringToFogMode(const std::string& mode) {
-    if(mode == "GL_LINEAR")
-        return GL_LINEAR;
-    else if(mode == "GL_EXP")
-        return GL_EXP;
-    else if(mode == "GL_EXP2" )
-        return GL_EXP2;
-    else
-        return -1;
-}
-
-
Index: /branches/atmospheric_engine/src/lib/graphics/effects/fog_effect.h
===================================================================
--- /branches/atmospheric_engine/src/lib/graphics/effects/fog_effect.h	(revision 8520)
+++ /branches/atmospheric_engine/src/lib/graphics/effects/fog_effect.h	(revision 8521)
@@ -63,5 +63,14 @@
 
 private:
-    GLint stringToFogMode(const std::string& mode);
+    inline GLint stringToFogMode(const std::string& mode) {
+        if(mode == "GL_LINEAR")
+            return GL_LINEAR;
+        else if(mode == "GL_EXP")
+            return GL_EXP;
+        else if(mode == "GL_EXP2" )
+            return GL_EXP2;
+        else
+            return -1;
+    }
 
     bool          fogActivate;
Index: /branches/atmospheric_engine/src/lib/graphics/effects/rain_effect.cc
===================================================================
--- /branches/atmospheric_engine/src/lib/graphics/effects/rain_effect.cc	(revision 8520)
+++ /branches/atmospheric_engine/src/lib/graphics/effects/rain_effect.cc	(revision 8521)
@@ -39,5 +39,5 @@
 
 /* TODO:
-  - test multiple rain emitters
+  - test multiple rain emitters <-- doesn't work
   - Think about what happens with building poss. to hang movewithcam off
   - Possible to activate lightening
@@ -207,4 +207,5 @@
         // increase sound volume
         // this->soundSource.fadein(this->rainBuffer, 10);
+
     } else if ( this->rainFadeOutDuration != 0 ) {
         if ( this->localTimer < this->rainFadeOutDuration ) {
@@ -227,4 +228,5 @@
             // decrease sound volume
             // this->soundSource.fadeout(this->rainBuffer, 10);
+
         } else
             this->deactivate();
@@ -258,2 +260,9 @@
 
 }
+
+void RainEffect::hideRain() {
+
+  RainEffect::rainParticles->setColor(0, 0,0,0, 0);
+  RainEffect::rainParticles->setColor(0, 0,0,0, 0);
+
+}
Index: /branches/atmospheric_engine/src/lib/graphics/effects/rain_effect.h
===================================================================
--- /branches/atmospheric_engine/src/lib/graphics/effects/rain_effect.h	(revision 8520)
+++ /branches/atmospheric_engine/src/lib/graphics/effects/rain_effect.h	(revision 8521)
@@ -37,4 +37,5 @@
         this->activate();
     }
+
     inline void deactivateRain() {
         this->deactivate();
@@ -45,4 +46,6 @@
     void startRaining();
     void stopRaining();
+
+    void hideRain();
 
     inline void setRainCoord(float x, float y, float z) {
@@ -84,26 +87,26 @@
     ParticleEmitter*            emitter;
 
-    GLfloat         rainFadeInDuration;
-    GLfloat         rainFadeOutDuration;
-    float           localTimer;
+    GLfloat                     rainFadeInDuration;
+    GLfloat                     rainFadeOutDuration;
+    float                       localTimer;
 
-    Vector          rainCoord;
-    Vector2D        rainSize;
-    GLfloat         rainRate;
-    GLfloat         rainVelocity;
-    GLfloat         rainLife;
-    GLfloat         rainMaxParticles;
-    int             rainWindForce;
-    bool            rainMove;
-    bool            rainActivate;
+    Vector                      rainCoord;
+    Vector2D                    rainSize;
+    GLfloat                     rainRate;
+    GLfloat                     rainVelocity;
+    GLfloat                     rainLife;
+    GLfloat                     rainMaxParticles;
+    int                         rainWindForce;
+    bool                        rainMove;
+    bool                        rainActivate;
 
-    OrxSound::SoundSource     soundSource;
+    OrxSound::SoundSource       soundSource;
     OrxSound::SoundBuffer*      rainBuffer;
     OrxSound::SoundBuffer*      windBuffer;
 
-    float         soundRainVolume;
+    float                       soundRainVolume;
 
-    LightManager*       lightMan;
-    GLfloat         rainAmbient;
+    LightManager*               lightMan;
+    GLfloat                     rainAmbient;
 
 };
Index: /branches/atmospheric_engine/src/lib/graphics/effects/sun_effect.cc
===================================================================
--- /branches/atmospheric_engine/src/lib/graphics/effects/sun_effect.cc	(revision 8520)
+++ /branches/atmospheric_engine/src/lib/graphics/effects/sun_effect.cc	(revision 8521)
@@ -56,5 +56,5 @@
  *  initializes the graphics effect
  */
-bool SunEffect::init()
+void SunEffect::init()
 {}
 
Index: /branches/atmospheric_engine/src/lib/graphics/effects/sun_effect.h
===================================================================
--- /branches/atmospheric_engine/src/lib/graphics/effects/sun_effect.h	(revision 8520)
+++ /branches/atmospheric_engine/src/lib/graphics/effects/sun_effect.h	(revision 8521)
@@ -1,5 +1,5 @@
 /*!
  * @file sun_effect.h
- *  
+ *
  */
 
@@ -20,8 +20,8 @@
     virtual void loadParams(const TiXmlElement* root);
 
-    virtual bool init();
+    virtual void init();
 
-    virtual bool activate() = 0;
-    virtual bool deactivate() = 0;
+    virtual void activate() = 0;
+    virtual void deactivate() = 0;
 
     virtual void draw() const;